<?php
/*
  $Id: easypopulate_functions.php,v 2.76a 2006/10/16 22:50:52 surfalot Exp $

  Designed for osCommerce, Open Source E-Commerce Solutions
  http://www.oscommerce.com

  Copyright (c) 2003 osCommerce

  Released under the GNU General Public License
*/
function DisplayCell($field, $name) {
    return ['text' => '<table border="0" cellpadding="0" cellspacing="0" width="100%"><tr>
    <td class="isCell" width="130"><label><span style="width:10px;padding-right:6px;">' . 
     tep_draw_checkbox_field($field, 'show', (!empty($_GET[$field])?true:false)) . 
     '</span>' .
     $name . '</label></td></tr></table>'];
} 

function DisplayMsg($msgArray) {
    if (tep_not_null($msgArray)) {
        return '<p class="' . $msgArray['color'] . ' ' . $msgArray['bkgnd'] . ' text-center">' . $msgArray['msg'] . '</p>';
    }
    return '';
}

function DisplayOption($name) {
 global $options_array; 
 echo '<INPUT TYPE="radio" NAME="' . $name . '" value="on"  onChange="this.form.submit();" ' . ($options_array[$name] ? "checked" : "") . '>yes&nbsp;' . 
      '<INPUT TYPE="radio" NAME="' . $name . '" value="off" onChange="this.form.submit();" ' . ($options_array[$name] ? '' : 'checked') . '>no&nbsp;&nbsp;';
 
} 

function GetDefaultOptions($system) {
    $db_query = tep_db_query("SHOW TABLES LIKE 'easypopulate'"); 
    if (tep_db_num_rows($db_query)) {
        $db_query = tep_db_query("select * from easypopulate");
        $db = tep_db_fetch_array($db_query);
        if ($system['model_size'] != $db['option_model_size']) {
            return SaveDefaultOptions($system);
        } 

        return $db;
    } 
    
    $options_array = [];
    $options_array['option_mvs'] = 0;  // Multi Vendor System (MVS) 1.2 support
    $options_array['option_product_images'] = 1;  // product images
    $options_array['option_quantity_prices'] = 0;  // quantity price breaks
    $options_array['option_header_tags_seo'] = 0;  
    $options_array['option_sppc'] = 0;   
    $options_array['option_extra_fields'] = 0;   
    $options_array['option_pdf_upload'] = 0;   
    $options_array['option_master_products'] = 0;  
    $options_array['option_xsell'] = 0;  
    $options_array['option_model_size'] = 255;  
    
    return $options_array;
}

function GetSystemDetails() {
    $system = (new system_info())->get_data();

    $db_query = tep_db_query("SELECT COLUMN_NAME, CHARACTER_MAXIMUM_LENGTH as model_size
          FROM information_schema.COLUMNS AS ins
          WHERE table_schema = '" . DB_DATABASE . "' and ins.TABLE_NAME = 'products' AND ins.DATA_TYPE = 'varchar' AND ins.COLUMN_NAME = 'products_model'");
    $db = tep_db_fetch_array($db_query);
    $system['model_size'] = $db['model_size'];
    return $system;
}

function SaveDefaultOptions($system) {
    $db_query = tep_db_query("SHOW TABLES LIKE 'easypopulate'"); 
    if (tep_db_num_rows($db_query)) {
        tep_db_query("DROP table easypopulate");
    } 
    tep_db_query("CREATE TABLE easypopulate (
                    option_mvs tinyint (1) default 0,
                    option_product_images tinyint (1) default 0,
                    option_quantity_prices tinyint (1) default 0,
                    option_header_tags_seo tinyint (1) default 0,
                    option_sppc tinyint (1) default 0,
                    option_extra_fields tinyint (1) default 0,
                    option_pdf_upload tinyint (1) default 0,
                    option_master_products tinyint (1) default 0,
                    option_xsell tinyint (1) default 0,
                    option_model_size smallint (4) default 255
                    )
                 ");
    $options_array = array('option_mvs' => (isset($_POST['option_mvs']) && $_POST['option_mvs'] == 'on' ? 1 : 0),
                           'option_product_images' => (isset($_POST['option_product_images']) && $_POST['option_product_images'] == 'on' ? 1 : 0),
                           'option_quantity_prices' => (isset($_POST['option_quantity_prices']) && $_POST['option_quantity_prices'] == 'on' ? 1 : 0),
                           'option_header_tags_seo' => (isset($_POST['option_header_tags_seo']) && $_POST['option_header_tags_seo'] == 'on' ? 1 : 0),
                           'option_sppc' => (isset($_POST['option_sppc']) && $_POST['option_sppc'] == 'on' ? 1 : 0),
                           'option_extra_fields' => (isset($_POST['option_extra_fields']) && $_POST['option_extra_fields'] == 'on' ? 1 : 0),
                           'option_pdf_upload' => (isset($_POST['option_pdf_upload']) && $_POST['option_pdf_upload'] == 'on' ? 1 : 0),
                           'option_master_products' => (isset($_POST['option_master_products']) && $_POST['option_master_products'] == 'on' ? 1 : 0),
                           'option_xsell' => (isset($_POST['option_xsell']) && $_POST['option_xsell'] == 'on' ? 1 : 0),
                           'option_model_size' => $system['model_size']
                     );
                     
    tep_db_perform('easypopulate', $options_array); 
    return $options_array;
} 

if (!function_exists('tep_get_uploaded_file')){
function tep_get_uploaded_file($filename) {
	if (isset($_FILES[$filename])) {
		$uploaded_file = array('name' => $_FILES[$filename]['name'],
		'type' => $_FILES[$filename]['type'],
		'size' => $_FILES[$filename]['size'],
		'tmp_name' => $_FILES[$filename]['tmp_name']);
	} elseif (isset($GLOBALS['_POST'][$filename])) {
		$uploaded_file = array('name' => $_POST[$filename]['name'],
		'type' => $_POST[$filename]['type'],
		'size' => $_POST[$filename]['size'],
		'tmp_name' => $_POST[$filename]['tmp_name']);
	} else {
		$uploaded_file = array('name' => $GLOBALS[$filename . '_name'],
		'type' => $GLOBALS[$filename . '_type'],
		'size' => $GLOBALS[$filename . '_size'],
		'tmp_name' => $GLOBALS[$filename]);
	}

return $uploaded_file;
}
}

// the $filename parameter is an array with the following elements:
// name, type, size, tmp_name
function tep_copy_uploaded_file($filename, $target) {
	if (substr($target, -1) != '/') $target .= '/';

	$target .= $filename['name'];

	move_uploaded_file($filename['tmp_name'], $target);
}

////
// Recursively go through the categories and retreive all sub-categories IDs
// TABLES: categories
if (!function_exists('tep_get_sub_categories')) {
  function tep_get_sub_categories(&$categories, $categories_id) {
    $sub_categories_query = tep_db_query("select categories_id from categories where parent_id = '" . (int)$categories_id . "'");
    if (tep_db_num_rows($sub_categories_query)) {
      while ($sub_categories = tep_db_fetch_array($sub_categories_query)) {
        if ($sub_categories['categories_id'] == 0) return true;
        $categories[sizeof($categories)] = $sub_categories['categories_id'];
        if ($sub_categories['categories_id'] != $categories_id) {
          tep_get_sub_categories($categories, $sub_categories['categories_id']);
        }
      }
    }
  }
}

if (!function_exists('tep_get_tax_class_rate')){
function tep_get_tax_class_rate($tax_class_id) {
	$tax_multiplier = 0;
	$tax_query = tep_db_query("select SUM(tax_rate) as tax_rate from tax_rates WHERE  tax_class_id = '" . $tax_class_id . "' GROUP BY tax_priority");
	if (tep_db_num_rows($tax_query)) {
		while ($tax = tep_db_fetch_array($tax_query)) {
			$tax_multiplier += $tax['tax_rate'];
		}
	}
	return $tax_multiplier;
}
}

if (!function_exists('tep_get_tax_title_class_id')){
function tep_get_tax_title_class_id($tax_class_title) {
	$classes_query = tep_db_query("select tax_class_id from tax_class WHERE tax_class_title = '" . $tax_class_title . "'" );
 if (tep_db_num_rows($classes_query)) {
     $tax_class_array = tep_db_fetch_array($classes_query);
     $tax_class_id = $tax_class_array['tax_class_id'];
     return $tax_class_id ;
 }
 return 0;
}
}

if (!function_exists('print_el')){
function print_el( $item2 ) {
	echo " | " . substr(strip_tags($item2), 0, 10);
}
}

if (!function_exists('print_el1')){
function print_el1( $item2 ) {
	echo sprintf("| %'.4s ", substr(strip_tags($item2), 0, 80));
}
}


